export const clamp = (value: number, min: number, max: number): number => {
	return Math.max(min, Math.min(max, value));
};

export const normalize = (value: number, min: number, max: number): number => {
	return (value - min) / (max - min);
};

export const lerp = (start: number, end: number, t: number): number => {
	return start + (end - start) * t;
};

export const calculateDistance = (
	x1: number,
	y1: number,
	x2: number,
	y2: number
): number => {
	const dx = x2 - x1;
	const dy = y2 - y1;
	return Math.hypot(dx, dy);
};

export const average = (numbers: number[]): number => {
	return numbers.length ? numbers.reduce((sum, val) => sum + val, 0) / numbers.length : 0;
};
