import { ViewportOffset, CONSTANTS } from '../types';
import { clamp } from './math';

export const calculateZoomDelta = (
	wheelDelta: number,
	accelerationFactor: number,
	baseMultiplier = 0.001
): number => {
	return clamp(wheelDelta * baseMultiplier * accelerationFactor, -0.5, 0.5);
};

export const calculateInitialViewport = (initialZoom: number): ViewportOffset => ({
	x: (CONSTANTS.VIRTUAL_CANVAS_SIZE - window.innerWidth / initialZoom) / 2,
	y: (CONSTANTS.VIRTUAL_CANVAS_SIZE - window.innerHeight / initialZoom) / 2,
});

export const clampZoom = (zoom: number): number => {
	return Math.max(CONSTANTS.ZOOM_LEVELS.min, Math.min(CONSTANTS.ZOOM_LEVELS.max, zoom));
};